Filesystem TS
Experimental
Collaboration diagram for Filesystem TS:

## Classes

class | std::experimental::filesystem::v1::path

## Typedefs

using | std::experimental::filesystem::file_time_type = std::chrono::system_clock::time_point

## Enumerations

enum class | std::experimental::filesystem::copy_options : unsigned short { none , skip_existing , overwrite_existing , update_existing , recursive , copy_symlinks , skip_symlinks , directories_only , create_symlinks , create_hard_links }
enum class | directory_options : unsigned char { none , follow_directory_symlink , skip_permission_denied }
enum class | file_type : signed char { none , not_found , regular , directory , symlink , block , character , fifo , socket , unknown }
enum class | std::experimental::filesystem::perms : unsigned { none , owner_read , owner_write , owner_exec , owner_all , group_read , group_write , group_exec , group_all , others_read , others_write , others_exec , others_all , all , set_uid , set_gid , sticky_bit , mask , unknown , add_perms , remove_perms , symlink_nofollow }

## Functions

void | std::experimental::filesystem::copy (const path &__from, const path &__to, copy_options __options)
void | std::experimental::filesystem::copy (const path &__from, const path &__to, copy_options __options, error_code &) noexcept
bool | std::experimental::filesystem::copy_file (const path &__from, const path &__to, copy_options __option)
bool | std::experimental::filesystem::copy_file (const path &__from, const path &__to, copy_options __option, error_code &)
path | std::experimental::filesystem::current_path ()
bool | std::experimental::filesystem::is_regular_file (file_status) noexcept
bool | std::experimental::filesystem::is_symlink (file_status) noexcept
constexpr copy_options | std::experimental::filesystem::operator& (copy_options __x, copy_options __y) noexcept
constexpr directory_options | std::experimental::filesystem::operator& (directory_options __x, directory_options __y) noexcept
constexpr perms | std::experimental::filesystem::operator& (perms __x, perms __y) noexcept
copy_options & | std::experimental::filesystem::operator&= (copy_options &__x, copy_options __y) noexcept
directory_options & | std::experimental::filesystem::operator&= (directory_options &__x, directory_options __y) noexcept
perms & | std::experimental::filesystem::operator&= (perms &__x, perms __y) noexcept
constexpr copy_options | std::experimental::filesystem::operator^ (copy_options __x, copy_options __y) noexcept
constexpr directory_options | std::experimental::filesystem::operator^ (directory_options __x, directory_options __y) noexcept
constexpr perms | std::experimental::filesystem::operator^ (perms __x, perms __y) noexcept
copy_options & | std::experimental::filesystem::operator^= (copy_options &__x, copy_options __y) noexcept
directory_options & | std::experimental::filesystem::operator^= (directory_options &__x, directory_options __y) noexcept
perms & | std::experimental::filesystem::operator^= (perms &__x, perms __y) noexcept
constexpr copy_options | std::experimental::filesystem::operator| (copy_options __x, copy_options __y) noexcept
constexpr directory_options | std::experimental::filesystem::operator| (directory_options __x, directory_options __y) noexcept
constexpr perms | std::experimental::filesystem::operator| (perms __x, perms __y) noexcept
copy_options & | std::experimental::filesystem::operator|= (copy_options &__x, copy_options __y) noexcept
directory_options & | std::experimental::filesystem::operator|= (directory_options &__x, directory_options __y) noexcept
perms & | std::experimental::filesystem::operator|= (perms &__x, perms __y) noexcept
constexpr copy_options | std::experimental::filesystem::operator~ (copy_options __x) noexcept
constexpr directory_options | std::experimental::filesystem::operator~ (directory_options __x) noexcept
constexpr perms | std::experimental::filesystem::operator~ (perms __x) noexcept
file_status | std::experimental::filesystem::status (const path &)
file_status | std::experimental::filesystem::status (const path &, error_code &) noexcept
bool | std::experimental::filesystem::status_known (file_status) noexcept
file_status | std::experimental::filesystem::symlink_status (const path &)
file_status | std::experimental::filesystem::symlink_status (const path &, error_code &) noexcept
path | std::experimental::filesystem::absolute (const path &__p, const path &__base=current_path())
path | std::experimental::filesystem::canonical (const path &__p, const path &__base=current_path())
path | std::experimental::filesystem::canonical (const path &__p, error_code &__ec)
path | std::experimental::filesystem::canonical (const path &__p, const path &__base, error_code &__ec)
void | std::experimental::filesystem::copy (const path &__from, const path &__to)
void | std::experimental::filesystem::copy (const path &__from, const path &__to, error_code &__ec) noexcept
bool | std::experimental::filesystem::copy_file (const path &__from, const path &__to)
bool | std::experimental::filesystem::copy_file (const path &__from, const path &__to, error_code &__ec)
void | std::experimental::filesystem::copy_symlink (const path &__existing_symlink, const path &__new_symlink)
void | std::experimental::filesystem::copy_symlink (const path &__existing_symlink, const path &__new_symlink, error_code &__ec) noexcept
bool | std::experimental::filesystem::create_directories (const path &__p)
bool | std::experimental::filesystem::create_directories (const path &__p, error_code &__ec)
bool | std::experimental::filesystem::create_directory (const path &__p)
bool | std::experimental::filesystem::create_directory (const path &__p, error_code &__ec) noexcept
bool | std::experimental::filesystem::create_directory (const path &__p, const path &attributes)
bool | std::experimental::filesystem::create_directory (const path &__p, const path &attributes, error_code &__ec) noexcept
void | std::experimental::filesystem::create_directory_symlink (const path &__to, const path &__new_symlink)
void | std::experimental::filesystem::create_directory_symlink (const path &__to, const path &__new_symlink, error_code &__ec) noexcept
void | std::experimental::filesystem::create_hard_link (const path &__to, const path &__new_hard_link)
void | std::experimental::filesystem::create_hard_link (const path &__to, const path &__new_hard_link, error_code &__ec) noexcept
void | std::experimental::filesystem::create_symlink (const path &__to, const path &__new_symlink)
void | std::experimental::filesystem::create_symlink (const path &__to, const path &__new_symlink, error_code &__ec) noexcept
path | std::experimental::filesystem::current_path (error_code &__ec)
void | std::experimental::filesystem::current_path (const path &__p)
void | std::experimental::filesystem::current_path (const path &__p, error_code &__ec) noexcept
bool | std::experimental::filesystem::equivalent (const path &__p1, const path &__p2)
bool | std::experimental::filesystem::equivalent (const path &__p1, const path &__p2, error_code &__ec) noexcept
bool | std::experimental::filesystem::exists (file_status __s) noexcept
bool | std::experimental::filesystem::exists (const path &__p)
bool | std::experimental::filesystem::exists (const path &__p, error_code &__ec) noexcept
uintmax_t | std::experimental::filesystem::file_size (const path &__p)
uintmax_t | std::experimental::filesystem::file_size (const path &__p, error_code &__ec) noexcept
uintmax_t | std::experimental::filesystem::hard_link_count (const path &__p)
uintmax_t | std::experimental::filesystem::hard_link_count (const path &__p, error_code &__ec) noexcept
bool | std::experimental::filesystem::is_block_file (file_status __s) noexcept
bool | std::experimental::filesystem::is_block_file (const path &__p)
bool | std::experimental::filesystem::is_block_file (const path &__p, error_code &__ec) noexcept
bool | std::experimental::filesystem::is_character_file (file_status __s) noexcept
bool | std::experimental::filesystem::is_character_file (const path &__p)
bool | std::experimental::filesystem::is_character_file (const path &__p, error_code &__ec) noexcept
bool | std::experimental::filesystem::is_directory (file_status __s) noexcept
bool | std::experimental::filesystem::is_directory (const path &__p)
bool | std::experimental::filesystem::is_directory (const path &__p, error_code &__ec) noexcept
bool | std::experimental::filesystem::is_empty (const path &__p)
bool | std::experimental::filesystem::is_empty (const path &__p, error_code &__ec) noexcept
bool | std::experimental::filesystem::is_fifo (file_status __s) noexcept
bool | std::experimental::filesystem::is_fifo (const path &__p)
bool | std::experimental::filesystem::is_fifo (const path &__p, error_code &__ec) noexcept
bool | std::experimental::filesystem::is_other (file_status __s) noexcept
bool | std::experimental::filesystem::is_other (const path &__p)
bool | std::experimental::filesystem::is_other (const path &__p, error_code &__ec) noexcept
bool | std::experimental::filesystem::is_regular_file (const path &__p)
bool | std::experimental::filesystem::is_regular_file (const path &__p, error_code &__ec) noexcept
bool | std::experimental::filesystem::is_socket (file_status __s) noexcept
bool | std::experimental::filesystem::is_socket (const path &__p)
bool | std::experimental::filesystem::is_socket (const path &__p, error_code &__ec) noexcept
bool | std::experimental::filesystem::is_symlink (const path &__p)
bool | std::experimental::filesystem::is_symlink (const path &__p, error_code &__ec) noexcept
file_time_type | std::experimental::filesystem::last_write_time (const path &__p)
file_time_type | std::experimental::filesystem::last_write_time (const path &__p, error_code &__ec) noexcept
void | std::experimental::filesystem::last_write_time (const path &__p, file_time_type __new_time)
void | std::experimental::filesystem::last_write_time (const path &__p, file_time_type __new_time, error_code &__ec) noexcept
void | std::experimental::filesystem::permissions (const path &__p, perms __prms)
void | std::experimental::filesystem::permissions (const path &__p, perms __prms, error_code &__ec) noexcept
path | std::experimental::filesystem::read_symlink (const path &__p)
path | std::experimental::filesystem::read_symlink (const path &__p, error_code &__ec)
bool | std::experimental::filesystem::remove (const path &__p)
bool | std::experimental::filesystem::remove (const path &__p, error_code &__ec) noexcept
uintmax_t | std::experimental::filesystem::remove_all (const path &__p)
uintmax_t | std::experimental::filesystem::remove_all (const path &__p, error_code &__ec)
void | std::experimental::filesystem::rename (const path &__from, const path &__to)
void | std::experimental::filesystem::rename (const path &__from, const path &__to, error_code &__ec) noexcept
void | std::experimental::filesystem::resize_file (const path &__p, uintmax_t __size)
void | std::experimental::filesystem::resize_file (const path &__p, uintmax_t __size, error_code &__ec) noexcept
space_info | std::experimental::filesystem::space (const path &__p)
space_info | std::experimental::filesystem::space (const path &__p, error_code &__ec) noexcept
path | std::experimental::filesystem::system_complete (const path &__p)
path | std::experimental::filesystem::system_complete (const path &__p, error_code &__ec)
path | std::experimental::filesystem::temp_directory_path ()
path | std::experimental::filesystem::temp_directory_path (error_code &__ec)

## Detailed Description

Utilities for performing operations on file systems and their components, such as paths, regular files, and directories.

## Typedef Documentation

## file_time_type

using std::experimental::filesystem::v1::file_time_type = typedef std::chrono::system_clock::time_point

Definition at line 256 of file experimental/bits/fs_fwd.h.

## Enumeration Type Documentation

## copy_options

enum class std::experimental::filesystem::v1::copy_options : unsigned short

strong

Bitmask type.

Definition at line 87 of file experimental/bits/fs_fwd.h.

## directory_options

enum class std::experimental::filesystem::v1::directory_options : unsigned char

strong

Definition at line 209 of file experimental/bits/fs_fwd.h.

## file_type

enum class std::experimental::filesystem::v1::file_type : signed char

strong

Definition at line 81 of file experimental/bits/fs_fwd.h.

## perms

enum class std::experimental::filesystem::v1::perms : unsigned

strong

Bitmask type.

Definition at line 140 of file experimental/bits/fs_fwd.h.

## Function Documentation

## copy() [1/2]

void std::experimental::filesystem::v1::copy | ( | const path & | __from,
|  | const path & | __to
| ) |  |

inline

Definition at line 61 of file experimental/bits/fs_ops.h.

## copy() [2/2]

void std::experimental::filesystem::v1::copy | ( | const path & | __from,
|  | const path & | __to,
|  | error_code & | __ec
| ) |  |

inline noexcept

Definition at line 65 of file experimental/bits/fs_ops.h.

## copy_file() [1/2]

bool std::experimental::filesystem::v1::copy_file | ( | const path & | __from,
|  | const path & | __to
| ) |  |

inline

Definition at line 73 of file experimental/bits/fs_ops.h.

## copy_file() [2/2]

bool std::experimental::filesystem::v1::copy_file | ( | const path & | __from,
|  | const path & | __to,
|  | error_code & | __ec
| ) |  |

inline

Definition at line 77 of file experimental/bits/fs_ops.h.

## exists() [1/3]

bool std::experimental::filesystem::v1::exists | ( | const path & | __p | ) |

inline

Definition at line 126 of file experimental/bits/fs_ops.h.

## exists() [2/3]

bool std::experimental::filesystem::v1::exists | ( | const path & | __p,
|  | error_code & | __ec
| ) |  |

inline noexcept

Definition at line 130 of file experimental/bits/fs_ops.h.

## exists() [3/3]

bool std::experimental::filesystem::v1::exists | ( | file_status | __s | ) |

inline noexcept

Definition at line 122 of file experimental/bits/fs_ops.h.

## is_block_file() [1/3]

bool std::experimental::filesystem::v1::is_block_file | ( | const path & | __p | ) |

inline

Definition at line 152 of file experimental/bits/fs_ops.h.

## is_block_file() [2/3]

bool std::experimental::filesystem::v1::is_block_file | ( | const path & | __p,
|  | error_code & | __ec
| ) |  |

inline noexcept

Definition at line 156 of file experimental/bits/fs_ops.h.

## is_block_file() [3/3]

bool std::experimental::filesystem::v1::is_block_file | ( | file_status | __s | ) |

inline noexcept

Definition at line 148 of file experimental/bits/fs_ops.h.

## is_character_file() [1/3]

bool std::experimental::filesystem::v1::is_character_file | ( | const path & | __p | ) |

inline

Definition at line 164 of file experimental/bits/fs_ops.h.

## is_character_file() [2/3]

bool std::experimental::filesystem::v1::is_character_file | ( | const path & | __p,
|  | error_code & | __ec
| ) |  |

inline noexcept

Definition at line 168 of file experimental/bits/fs_ops.h.

## is_character_file() [3/3]

bool std::experimental::filesystem::v1::is_character_file | ( | file_status | __s | ) |

inline noexcept

Definition at line 160 of file experimental/bits/fs_ops.h.

## is_directory() [1/3]

bool std::experimental::filesystem::v1::is_directory | ( | const path & | __p | ) |

inline

Definition at line 176 of file experimental/bits/fs_ops.h.

## is_directory() [2/3]

bool std::experimental::filesystem::v1::is_directory | ( | const path & | __p,
|  | error_code & | __ec
| ) |  |

inline noexcept

Definition at line 180 of file experimental/bits/fs_ops.h.

## is_directory() [3/3]

bool std::experimental::filesystem::v1::is_directory | ( | file_status | __s | ) |

inline noexcept

Definition at line 172 of file experimental/bits/fs_ops.h.

## is_fifo() [1/3]

bool std::experimental::filesystem::v1::is_fifo | ( | const path & | __p | ) |

inline

Definition at line 191 of file experimental/bits/fs_ops.h.

## is_fifo() [2/3]

bool std::experimental::filesystem::v1::is_fifo | ( | const path & | __p,
|  | error_code & | __ec
| ) |  |

inline noexcept

Definition at line 195 of file experimental/bits/fs_ops.h.

## is_fifo() [3/3]

bool std::experimental::filesystem::v1::is_fifo | ( | file_status | __s | ) |

inline noexcept

Definition at line 187 of file experimental/bits/fs_ops.h.

## is_other() [1/3]

bool std::experimental::filesystem::v1::is_other | ( | const path & | __p | ) |

inline

Definition at line 206 of file experimental/bits/fs_ops.h.

## is_other() [2/3]

bool std::experimental::filesystem::v1::is_other | ( | const path & | __p,
|  | error_code & | __ec
| ) |  |

inline noexcept

Definition at line 210 of file experimental/bits/fs_ops.h.

## is_other() [3/3]

bool std::experimental::filesystem::v1::is_other | ( | file_status | __s | ) |

inline noexcept

Definition at line 199 of file experimental/bits/fs_ops.h.

## is_regular_file() [1/3]

bool std::experimental::filesystem::v1::is_regular_file | ( | const path & | __p | ) |

inline

Definition at line 218 of file experimental/bits/fs_ops.h.

## is_regular_file() [2/3]

bool std::experimental::filesystem::v1::is_regular_file | ( | const path & | __p,
|  | error_code & | __ec
| ) |  |

inline noexcept

Definition at line 222 of file experimental/bits/fs_ops.h.

## is_regular_file() [3/3]

bool std::experimental::filesystem::v1::is_regular_file | ( | file_status | __s | ) |

inline noexcept

Definition at line 214 of file experimental/bits/fs_ops.h.

## is_socket() [1/3]

bool std::experimental::filesystem::v1::is_socket | ( | const path & | __p | ) |

inline

Definition at line 230 of file experimental/bits/fs_ops.h.

## is_socket() [2/3]

bool std::experimental::filesystem::v1::is_socket | ( | const path & | __p,
|  | error_code & | __ec
| ) |  |

inline noexcept

Definition at line 234 of file experimental/bits/fs_ops.h.

## is_socket() [3/3]

bool std::experimental::filesystem::v1::is_socket | ( | file_status | __s | ) |

inline noexcept

Definition at line 226 of file experimental/bits/fs_ops.h.

## is_symlink() [1/3]

bool std::experimental::filesystem::v1::is_symlink | ( | const path & | __p | ) |

inline

Definition at line 242 of file experimental/bits/fs_ops.h.

## is_symlink() [2/3]

bool std::experimental::filesystem::v1::is_symlink | ( | const path & | __p,
|  | error_code & | __ec
| ) |  |

inline noexcept

Definition at line 246 of file experimental/bits/fs_ops.h.

## is_symlink() [3/3]

bool std::experimental::filesystem::v1::is_symlink | ( | file_status | __s | ) |

inline noexcept

Definition at line 238 of file experimental/bits/fs_ops.h.

## operator&() [1/3]

constexpr copy_options std::experimental::filesystem::v1::operator& | ( | copy_options | __x,
|  | copy_options | __y
| ) |  |

constexpr noexcept

Definition at line 96 of file experimental/bits/fs_fwd.h.

## operator&() [2/3]

constexpr directory_options std::experimental::filesystem::v1::operator& | ( | directory_options | __x,
|  | directory_options | __y
| ) |  |

constexpr noexcept

Definition at line 214 of file experimental/bits/fs_fwd.h.

## operator&() [3/3]

constexpr perms std::experimental::filesystem::v1::operator& | ( | perms | __x,
|  | perms | __y
| ) |  |

constexpr noexcept

Definition at line 166 of file experimental/bits/fs_fwd.h.

## operator&=() [1/3]

copy_options & std::experimental::filesystem::v1::operator&= | ( | copy_options & | __x,
|  | copy_options | __y
| ) |  |

inline noexcept

Definition at line 127 of file experimental/bits/fs_fwd.h.

## operator&=() [2/3]

directory_options & std::experimental::filesystem::v1::operator&= | ( | directory_options & | __x,
|  | directory_options | __y
| ) |  |

inline noexcept

Definition at line 245 of file experimental/bits/fs_fwd.h.

## operator&=() [3/3]

perms & std::experimental::filesystem::v1::operator&= | ( | perms & | __x,
|  | perms | __y
| ) |  |

inline noexcept

Definition at line 197 of file experimental/bits/fs_fwd.h.

## operator^() [1/3]

constexpr copy_options std::experimental::filesystem::v1::operator^ | ( | copy_options | __x,
|  | copy_options | __y
| ) |  |

constexpr noexcept

Definition at line 112 of file experimental/bits/fs_fwd.h.

## operator^() [2/3]

constexpr directory_options std::experimental::filesystem::v1::operator^ | ( | directory_options | __x,
|  | directory_options | __y
| ) |  |

constexpr noexcept

Definition at line 230 of file experimental/bits/fs_fwd.h.

## operator^() [3/3]

constexpr perms std::experimental::filesystem::v1::operator^ | ( | perms | __x,
|  | perms | __y
| ) |  |

constexpr noexcept

Definition at line 182 of file experimental/bits/fs_fwd.h.

## operator^=() [1/3]

copy_options & std::experimental::filesystem::v1::operator^= | ( | copy_options & | __x,
|  | copy_options | __y
| ) |  |

inline noexcept

Definition at line 135 of file experimental/bits/fs_fwd.h.

## operator^=() [2/3]

directory_options & std::experimental::filesystem::v1::operator^= | ( | directory_options & | __x,
|  | directory_options | __y
| ) |  |

inline noexcept

Definition at line 253 of file experimental/bits/fs_fwd.h.

## operator^=() [3/3]

perms & std::experimental::filesystem::v1::operator^= | ( | perms & | __x,
|  | perms | __y
| ) |  |

inline noexcept

Definition at line 205 of file experimental/bits/fs_fwd.h.

## operator|() [1/3]

constexpr copy_options std::experimental::filesystem::v1::operator| | ( | copy_options | __x,
|  | copy_options | __y
| ) |  |

constexpr noexcept

Definition at line 104 of file experimental/bits/fs_fwd.h.

## operator|() [2/3]

constexpr directory_options std::experimental::filesystem::v1::operator| | ( | directory_options | __x,
|  | directory_options | __y
| ) |  |

constexpr noexcept

Definition at line 222 of file experimental/bits/fs_fwd.h.

## operator|() [3/3]

constexpr perms std::experimental::filesystem::v1::operator| | ( | perms | __x,
|  | perms | __y
| ) |  |

constexpr noexcept

Definition at line 174 of file experimental/bits/fs_fwd.h.

## operator|=() [1/3]

copy_options & std::experimental::filesystem::v1::operator|= | ( | copy_options & | __x,
|  | copy_options | __y
| ) |  |

inline noexcept

Definition at line 131 of file experimental/bits/fs_fwd.h.

## operator|=() [2/3]

directory_options & std::experimental::filesystem::v1::operator|= | ( | directory_options & | __x,
|  | directory_options | __y
| ) |  |

inline noexcept

Definition at line 249 of file experimental/bits/fs_fwd.h.

## operator|=() [3/3]

perms & std::experimental::filesystem::v1::operator|= | ( | perms & | __x,
|  | perms | __y
| ) |  |

inline noexcept

Definition at line 201 of file experimental/bits/fs_fwd.h.

## operator~() [1/3]

constexpr copy_options std::experimental::filesystem::v1::operator~ | ( | copy_options | __x | ) |

constexpr noexcept

Definition at line 120 of file experimental/bits/fs_fwd.h.

## operator~() [2/3]

constexpr directory_options std::experimental::filesystem::v1::operator~ | ( | directory_options | __x | ) |

constexpr noexcept

Definition at line 238 of file experimental/bits/fs_fwd.h.

## operator~() [3/3]

constexpr perms std::experimental::filesystem::v1::operator~ | ( | perms | __x | ) |

constexpr noexcept

Definition at line 190 of file experimental/bits/fs_fwd.h.

## status_known()

bool std::experimental::filesystem::v1::status_known | ( | file_status | __s | ) |

inline noexcept

Definition at line 279 of file experimental/bits/fs_ops.h.